#include <iostream.h>
#include <stdlib.h>
//#include "book.h"

#include "binnode.h"

// Stick these in to test the preorder routine
template <class Elem>
void visit(const Elem& X) {cout << X->val() << endl;};

template <class Elem>
void preorder(BinNode<Elem>* subroot) {
  if (subroot == NULL) return;  // Empty subtree, do nothing
  visit(subroot);  // Perform whatever action is desired
  preorder(subroot->left());
  preorder(subroot->right());
}



// Test the preorder traversal routines
int main()
{
  BinNodePtr<int>* root = new BinNodePtr<int>(10);
  root->setLeft(new BinNodePtr<int>(15));
  root->setRight(new BinNodePtr<int>(20));
  preorder(root);
  return 1;
 }
